
import java.io.RandomAccessFile;
import javax.jms.Connection;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;
import com.ibm.websphere.sib.api.jms.JmsConnectionFactory;
import com.ibm.websphere.sib.api.jms.JmsFactoryFactory;
import com.ibm.websphere.sib.api.jms.JmsQueue;

public class JMS_Put_SSL {
	public static void main(String[] args) {
		//System.setProperty("javax.net.ssl.trustStore","DummyClientTrustFile.jks");
		//System.setProperty("javax.net.ssl.trustStorePassword","WebAS");
		//Hosted
		//MDMDEV1         158.177.138.11        10.194.38.81        MDM6t6-d-mdc1.fra02.eu-de.services.bluemix.net
		//Managed
		//MDM Server      158.177.112.105		10.194.38.23		mdmpxy-s-mdmp.fra02.eu-de.services.bluemix.net
		//Remote WAS Node 158.177.112.98		10.194.38.24		mdmpxy-s-mdms.fra02.eu-de.services.bluemix.net
		//MDM Portable IP 158.177.140.210
		
		/*
		 * 
keytool -import -trustcacerts -file /home/gb085768/IBM/WebSphereBase9.0/AppServer/profiles/AppSrv03/etc/DummyClientTrustFile.jks -alias DummyClientTrustFile -keystore /home/gb085768/IBM/WebSphereBase9.0/AppServer/java/8.0/jre/lib/security/cacerts

keytool -importkeystore    -srckeystore  /home/gb085768/IBM/WebSphereBase9.0/AppServer/profiles/AppSrv03/etc/DummyClientTrustFile.jks
		 keytool -importcert /home/gb085768/IBM/WebSphereBase9.0/AppServer/profiles/AppSrv03/etc/DummyClientTrustFile.jks
JAVA_HOME=/home/gb085768/IBM/WebSphereBase/AppServer/java_1.8_64		  
java -cp ".:./lib/*:bin:$JAVA_HOME/jre/lib/*" JMS_Put_SSL localhost:7286:BootstrapSecureMessaging MDM.SIB.server1 MDM.MESSAGING.REQUEST addPerson.xml		 
		 */
		
		if( args.length != 4) {
			System.out.println("Usage:");
			System.out.println("java  -cp \".:./lib/*:bin:$JAVA_HOME/jre/lib/*\" JMS_Put_SSL url busname queuename filename");
			System.out.println("eg");
			System.out.println("java -cp \".:./lib/*:bin:$JAVA_HOME/jre/lib/*\" -Djavax.net.ssl.trustStore=DummyClientTrustFile.jks -Djavax.net.ssl.trustStorePassword=WebAS  JMS_Put_SSL localhost:7286:BootstrapSecureMessaging MDM.SIB.server1 MDM.MESSAGING.REQUEST addPerson.xml");
			System.exit(-1);
		}

		JMS_Put_SSL test1 = new JMS_Put_SSL();

		String url       = args[0]; //"localhost:7286:BootstrapSecureMessaging";
		String busname   = args[1]; //"MDM.SIB.server1";
		String QueueName = args[2]; //"MDM.MESSAGING.REQUEST";
		String filename  = args[3]; //"addPerson.xml";

		test1.run(filename,QueueName,busname,url);
		System.exit(0);
	}
	/*
	 *
java -cp ".:./lib/*:bin:/home/gb085768/IBM/WebSphereBase/AppServer/java_1.8_64/jre/lib/*" JMS_Put_SSL -Djavax.net.ssl.trustStore=/home/gb085768/IBM/WebSphereBase9.0/AppServer/profiles/AppSrv03/etc/
	 * 
	 * 
	 * 	   */
	public void run(String filename, String QueueName, String busname, String url) {
		try {


			JmsFactoryFactory jff = JmsFactoryFactory.getInstance();
			JmsConnectionFactory jcf = jff.createConnectionFactory();
			jcf.setProviderEndpoints(url);
			jcf.setBusName(busname);
			JmsQueue queue = jff.createQueue(QueueName);
			Connection conn = jcf.createConnection();
			conn.start();
			// Read the file
			RandomAccessFile f = new RandomAccessFile(filename, "r");
			byte data[] = new byte[(int)f.length()];
			f.read(data);
			f.close();
			Session session = conn.createSession(false, Session.AUTO_ACKNOWLEDGE);
			TextMessage tm = session.createTextMessage(new String(data));
			MessageProducer producer = session.createProducer(queue);
			producer.send(tm);
			conn.close();
			System.out.println("Done!");
		} 
		catch (Exception e) {
			e.printStackTrace();
		}
	}
}
